<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

### Table of Contents

-   [constructor](#constructor)
-   [set](#set)
-   [get](#get)
-   [tree](#tree)
-   [flush](#flush)

## constructor

[index.js:43-47](https://github.com/ipld/js-ipld-graph-builder/blob/9d7417df5c458997584b73f5ae8b653be46f1828/index.js#L43-L47 "Source code on GitHub")

**Parameters**

-   `ipfsDag` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** an instance of [ipfs.dag](https://github.com/ipfs/interface-ipfs-core/tree/master/API/dag#dag-api)

## set

[index.js:78-102](https://github.com/ipld/js-ipld-graph-builder/blob/9d7417df5c458997584b73f5ae8b653be46f1828/index.js#L78-L102 "Source code on GitHub")

sets a value on a root object given its path

**Parameters**

-   `node` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** 
-   `path` **[String](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** 
-   `value` **any** 

Returns **[Promise](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise)** 

## get

[index.js:112-116](https://github.com/ipld/js-ipld-graph-builder/blob/9d7417df5c458997584b73f5ae8b653be46f1828/index.js#L112-L116 "Source code on GitHub")

traverses an object's path and returns the resulting value in a Promise

**Parameters**

-   `node` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** 
-   `path` **[String](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** 
-   `dropOptions` **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** whether to add the encoding options of the
    nodes when loading from IPFS. Defaults to true

Returns **[Promise](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise)** 

## tree

[index.js:160-179](https://github.com/ipld/js-ipld-graph-builder/blob/9d7417df5c458997584b73f5ae8b653be46f1828/index.js#L160-L179 "Source code on GitHub")

Resolves all the links in an object and does so recusivly for N `level`

**Parameters**

-   `node` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** 
-   `levels` **Integer**  (optional, default `1`)
-   `dropOptions` **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** whether to add the encoding options of the
    nodes when loading from IPFS. Defaults to true

Returns **[Promise](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise)** 

## flush

[index.js:205-218](https://github.com/ipld/js-ipld-graph-builder/blob/9d7417df5c458997584b73f5ae8b653be46f1828/index.js#L205-L218 "Source code on GitHub")

flush an object to ipfs returning the resulting CID in a promise

**Parameters**

-   `node` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** 
-   `opts` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** encoding options for [`dag.put`](https://github.com/ipfs/interface-ipfs-core/tree/master/API/dag#dagput) (optional, default `{}`)
    -   `opts.onHash` **[Function](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/function)** a callback that happens on each merklized node. It is given two arguments `hash` and `node` which is the node that was hashed

Returns **[Promise](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise)** 
